UNIT Marque;

INTERFACE

USES
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, stdctrls;

TYPE
{Definition for the balls Group Properties}
ballm = array[1..10,1..4] of integer;
{Types for the balls type}
tballstyle = (Transparent, Translucent, Opaque, Spotlight);
{Main Component Definition}
QCMarque = CLASS(TCustomPanel)
  PRIVATE
    tBallcolor: tcolor;
    tBalltype: tballstyle;
    tBallnumber:integer;
    tBallsize:integer;
    tBackcolor: tcolor;
    ftimer:integer;
    activate:boolean;
    tspeed:integer;
    tballspeed:integer;
    PROCEDURE setrunning(run:Boolean);
  PROTECTED
    PROCEDURE paint;override;
    PROCEDURE WMTimer(var Message: tmessage);message WM_Timer;
    PROCEDURE WMDestroy(var Message: Tmessage);message wm_destroy;
  PUBLIC
    CONSTRUCTOR Create(aowner: tcomponent) ; override;
    PROPERTY Running :boolean read activate write setrunning;
    PROCEDURE setballcolor(value:tcolor);
    PROCEDURE setballsize(value:integer);
    PROCEDURE setballType(value:tballstyle);
    PROCEDURE setballcount(value:integer);
    PROCEDURE setspeed(value:integer);
    PROCEDURE setballspeed(value:integer);
    PROCEDURE setBackcolor(value:tcolor);
  PUBLISHED
    PROPERTY BackColor: tcolor read tbackcolor write setbackcolor;
    PROPERTY Align;
    PROPERTY Caption;
    PROPERTY BallColor: tcolor Read tballcolor write setballcolor ;
    PROPERTY BallSize: integer Read Tballsize write setballsize ;
    PROPERTY BallType: tballStyle  Read TBallType Write setballType;
    PROPERTY BallCount: Integer Read Tballnumber Write setballcount ;
    PROPERTY BallSpeed: integer read tballspeed write setballspeed ;
    PROPERTY TextSpeed :integer Read tspeed Write setspeed ;
    PROPERTY Font ;
    PROPERTY Width ;
    PROPERTY Height;
 END;

PROCEDURE Register;
VAR
   i,iwin : integer;
   offmap2,offmap1 :tbitmap;
   twidth :tlabel;
   ballmove :ballm;

IMPLEMENTATION

CONSTRUCTOR QCMarque.create(aowner:tcomponent);
BEGIN
   inherited create(aowner);
   alignment := taleftjustify;
   height := 25;
   width := 75;
   offmap1 := tbitmap.create;
   offmap2 := tbitmap.create;
   twidth := tlabel.create(self);
   Font.name := 'TimesNewRoman';
   Font.Color := clWhite;
   ballcolor := clBlue;
   ballsize := 25;
   Ballcount := 1;
   Ballspeed := 1;
   TextSpeed := 1;
   Backcolor := clblack;
   invalidate;
END;

PROCEDURE QCMarque.WMTimer(var message: tmessage);
BEGIN
   for i := 1 to ballcount do BEGIN
      if (ballmove[i,1] < 0) or (ballmove[i,1] > width) then ballmove[i,3] :=  ballmove[i,3] * -1;
      if (ballmove[i,2] < 0) or (ballmove[i,2] > height) then ballmove[i,4] := ballmove[i,4] * -1;
      ballmove[i,1] := ballmove[i,1]+(ballmove[i,3]*ballspeed);
      ballmove[i,2] := ballmove[i,2]+(ballmove[i,4]*ballspeed);
   END;
   iwin := iwin - tSpeed;
   if iwin < -twidth.width then iwin := width;
   paint;
END;

PROCEDURE QCMarque.WmDestroy(var Message:tmessage);
BEGIN
   activate := false;
   killtimer(handle,ftimer);
   ftimer := 0;
   offmap1.free;
   offmap2.free;
   twidth.free;
   inherited;
END;

PROCEDURE QCMarque.paint;
VAR
   crect : trect;
BEGIN
   crect :=rect(0,0,Width,Height);
   {sets The Text Item}
   twidth.font := font;
   twidth.font.height := height;
   twidth.caption := caption;
   {Sets the Visible Text}
   Offmap1.Width := width;
   Offmap1.Height := height;
   Offmap1.Canvas.Font := Twidth.font;
   Offmap1.Canvas.brush.color := backcolor;
   Offmap1.Canvas.Fillrect(crect);
   Offmap1.Canvas.Textout(iwin,0,Twidth.caption);
   {Sets the Second Off Screen Buffer}
   Offmap2.Width := Width;
   Offmap2.Height := height;
   Offmap2.canvas.brush.color := backcolor;
   Offmap2.Canvas.fillrect(crect);
   {Draw Ball First}
   Offmap2.canvas.brush.color := ballcolor;
   If running then
      For i := 1 to Ballcount do
         Offmap2.canvas.ellipse(ballmove[i,1]-ballsize,ballmove[i,2]-ballsize,ballmove[i,1]
         +ballsize,ballmove[i,2]+ballsize)
   Else
      Offmap2.canvas.ellipse(-ballsize,-ballsize,+ballsize,+ballsize);
   {Draw Text}
   If Balltype = Translucent then Offmap2.canvas.copymode := cmsrcinvert;
   If (Balltype = Transparent) or(balltype = Opaque) then Offmap2.canvas.copymode := cmsrcpaint;
   If Balltype = Spotlight then Offmap2.canvas.copymode := cmsrcand;
   Offmap2.canvas.copyrect(crect,offmap1.canvas,crect);
   {Draw Ball After If Opaque }
   If BallType = Opaque then
      if Running then
         For i := 1 to Ballcount do
            Offmap2.canvas.ellipse(ballmove[i,1]-ballsize,ballmove[i,2]-ballsize,ballmove[i,1]
            +ballsize,ballmove[i,2]+ballsize)
      Else
         Offmap2.canvas.ellipse(-ballsize,-ballsize,+ballsize,+ballsize);
   {Draw to screen}
   Offmap2.Canvas.copymode := CMSRCAND;
   canvas.copyrect(crect,offmap2.canvas,crect);
END;

PROCEDURE QCMarque.setrunning(Run:boolean);
BEGIN
   if Run then
      BEGIN
         settimer(handle,ftimer,50,nil);
         activate := true;
         iwin := WIDTH;
         randomize;
         for I := 1 to ballcount do
            BEGIN
               ballmove[i,1] :=random(Width - 3)+1;
               ballmove[i,2] :=random(Height -3)+1;
               ballmove[i,3] := random(1);
               if ballmove[i,3] = 0 then ballmove[i,3] := -1;
               ballmove[i,4] := Random(1);
               if ballmove[i,4] = 0 then ballmove[i,4] := -1;
            END;
      END
   else
      BEGIN
         killtimer(handle,ftimer);
         activate :=false;
      END;
END;

PROCEDURE QCMarque.setballcolor(value:tcolor);
BEGIN
   tBallcolor := value;
   invalidate;
END;

PROCEDURE QCMarque.setballsize(value:integer);
BEGIN
   if (value >= 0) and (value<201) then tballsize := value;
   invalidate;
END;

PROCEDURE QCMarque.setballType(value:tballstyle);
BEGIN
   tballtype := value;
   invalidate;
END;

PROCEDURE QCMarque.setballcount(value:integer);
BEGIN
   if (value >= 0) and (value < 11) then tballnumber := value;
   invalidate;
END;

PROCEDURE QCMarque.setspeed(value:integer);
BEGIN
   if (value >=0) and (value < 6) then tspeed := value;
END;

PROCEDURE QCMarque.setballspeed(value:integer);
BEGIN
   if (value >=0) and (value <11) then tballspeed := value;
END;

PROCEDURE QCMarque.setbackcolor(value:tcolor);
BEGIN
   tbackcolor := value;
   invalidate;
END;

PROCEDURE Register;
BEGIN
  RegisterComponents('Samples', [QCMarque]);
END;

END.
